/* File: helper.h */

/*-----------------------------------------------------------------**
** Copyright (C) The Higher Education Statistics Agency 1994,1995  **
** Authors:                                                        **
** 	Duncan Charlton: DuncanC@hesa.ac.uk                            **
** 	Adrian Crossley: AdrianC@hesa.ac.uk                            **
** 	John Turner    :   JohnT@hesa.ac.uk                            **
**-----------------------------------------------------------------*/

/*-----------------------------------**
** Declarations of stuff in helper.c **
**-----------------------------------*/
extern int OwnStuId;
extern int OwnPsdId;
#ifdef ANSI		
BOOL IsItALeapYear(unsigned int nYear);
int CountType(char* szLookIn ,char* LookForType);		
int CheckTable(char *Item,char Table[][6]);		
int CheckTableDeFunct(int iFieldNo,struct DFQ  Table[]);
char *StripChar(char *term,char TakeOut);																	/* ANSI Style prorotypes */
int GetSub();  
int GetPer13();
void ShowDiag(const char *lps,UINT uiLevel);
char *GetLongErrorMessage(UINT ErrorNumber); 
UINT IsFieldRQD(UINT uiFieldNo);
UINT ValidateField(UINT uiFieldNo,struct ERROR *pError);
BOOL IgnoreRule(UINT uiRuleNo);
UINT GetFieldNoFromAbbrev(const PSZ pszAbbrev);
ULONG GetFieldNoInteger(UINT uiFieldNo);
PSZ GetFieldNoString(UINT uiFieldNo);

/* MDE: */
PSZ GetField(UINT uiFieldNo);

/* MDE 2005-05-06 */
PSZ CatFields(UINT uiFieldNo1,UINT uiFieldNo2);

/* DAB */
PSZ GetField2(UINT uiFieldNo);

/* DAB - 21 Jan 2004 */
BOOL IsValid8DigitDate(UINT uiFieldNo);

PSZ GetFieldNoStringMid(UINT uiFieldNo,int iStart,int iWidth);

/* DAB */
PSZ GetFieldNoStringMid2(UINT uiFieldNo,int iStart,int iWidth);

ULONG GetFieldNoIntegerMid(UINT uiFieldNo,int iStart,int iWidth);
BOOL IsValidInteger(UINT uiFieldNo,ULONG ulMin,ULONG ulMax);
BOOL _IsValidCode(struct FLD *pFld,const PSZ pszValue);
BOOL IsValidCode(UINT uiFieldNo);
BOOL _IsValidnDigitSocSicCode(struct FLD *pFld,const PSZ pszValue,int iN);
BOOL IsValidnDigitSocSicCode(UINT uiFieldNo,int iN);
BOOL IsValidCasocCode(UINT uiFieldNo);
BOOL IsValidCodeForField(UINT uiFieldNo,const PSZ pszValue);
BOOL IsValidAlphanum(UINT uiFieldNo,UINT uiMinLength,UINT uiMaxLength);
BOOL IsValidName(UINT uiFieldNo,UINT uiMinLength,UINT uiMaxLength);
BOOL IsCorrectType(UINT uiFieldNo,UINT uiMinLength,UINT uiMaxLength,PSZ pszStrType);
BOOL IsValidDate(UINT uiFieldNo);
PSZ GetFieldNoDate(UINT uiFieldNo);            	
SLONG _DateDiff(UINT uiInterval,const PSZ psz1,const PSZ psz2);
SLONG DateDiff(UINT uiInterval,UINT uiFieldNo1,UINT uiFieldNo2);                    
ULONG DateSplit(UINT uiInterval,UINT uiFieldNo1);                    
BOOL IsValidShortDate(UINT uiFieldNo);
BOOL IsReducedReturn(UINT uiReduced);
BOOL  GetGlobalSwitch(UINT uiSwitchNo);
BOOL CompFieldNoString(UINT uiFieldNo,const PSZ pszCompare,BOOL fCase);
BOOL IsReallyEmpty(UINT uiFieldNo);
BOOL IsEmpty(UINT uiFieldNo);
BOOL IsValidProportion(UINT uiFieldNo,UINT uiMin,UINT uiMax);
BOOL PostCodeOK_1(const PSZ pszCode);
BOOL PostCodeOK(UINT uiFieldNo);
BOOL PostCodeLooksOK(UINT uiFieldNo);
BOOL ChecksumOK(UINT uiFieldNo);
BOOL _IsFormat(const PSZ pszValue,const PSZ pszFormat);
BOOL IsFormat(UINT uiFieldNo,const PSZ pszFormat);
BOOL IsFirstBitOfHusidOK(UINT uiFieldNo);
BOOL IsOldInstInHusid(UINT uiCurFieldNo);
double GetFieldNoDouble(UINT uiFieldNo);
BOOL IsValidUnPaddedInteger(UINT uiFieldNo,ULONG ulMin,ULONG ulMax);
PSZ GetOutFieldNoString(UINT uiFieldNo);
#else			
										/* Non ANSI declarations */
BOOL IsItALeapYear(nYear);
int GetSub();						
int GetPer13();
char *StripChar();
char *GetLongErrorMessage(); 
void ShowDiag();                
UINT IsFieldRQD();
UINT ValidateField();
BOOL IgnoreRule();  
UINT GetFieldNoFromAbbrev();
PSZ GetFieldNoStringMid();
ULONG GetFieldNoIntegerMid();
ULONG GetFieldNoInteger();
PSZ GetFieldNoString();
PSZ GetFieldNoString2();
PSZ GetField();
BOOL IsValidInteger();
BOOL _IsValidCode();
BOOL IsValidCode();
BOOL _IsValidnDigitSocSicCode();
BOOL IsValidnDigitSocSicCode();
BOOL IsValidCasocCode();
BOOL IsValidCodeForField();
BOOL IsValidAlphanum();
BOOL IsValidDate();     
PSZ GetFieldNoDate();
SLONG _DateDiff();
SLONG DateDiff();                    
ULONG DateSplit();                    
BOOL IsValidShortDate();
BOOL IsValid8DigitDate();
BOOL IsReducedReturn();
BOOL  GetGlobalSwitch();
BOOL CompFieldNoString();
BOOL IsReallyEmpty();
BOOL IsEmpty();
BOOL IsValidProportion();
BOOL PostCodeOK_1();
BOOL PostCodeOK();
BOOL PostCodeLooksOK();
BOOL ChecksumOK();
BOOL _IsFormat();
BOOL IsFormat();
BOOL IsFirstBitOfHusidOK();
BOOL IsOldInstInHusid();
double GetFieldNoDouble();
BOOL IsValidUnPaddedInteger();
PSZ GetOutFieldNoString();
PSZ CatFields();
#endif

#ifdef ANSI
int strcmpi(const char *r, const char *o);
char *strdup(const char *string);
char *ltoa(long value,char *string,int radix);
#else
int strcmpi();                                
char *strdup();
char *ltoa();
#endif



